<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plaiframe Docs Source: mongo.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plaiframe Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-session.html">session</a></li><li><a href="module-variables.html">variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors-DesignError.html">errors~DesignError</a></li><li><a href="module-game-Game.html">game~Game</a></li><li><a href="module-medley-Log.html">medley~Log</a></li><li><a href="module-medley-Queue.html">medley~Queue</a></li><li><a href="module-mongo-Database.html">mongo~Database</a></li><li><a href="module-mongo-Collection.html">mongo~Collection</a></li><li><a href="module-mongo-Document.html">mongo~Document</a></li><li><a href="module-ne-Database.html">ne~Database</a></li><li><a href="module-ne-Collection.html">ne~Collection</a></li><li><a href="module-ne-Document.html">ne~Document</a></li><li><a href="module-session-Session.html">session~Session</a></li><li><a href="module-variables-Variables.html">variables~Variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="externals.list.html" class="dropdown-toggle" data-toggle="dropdown">Externals<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="external-Object.html">Object</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: mongo.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* Structures access to mongo database
*
* setup mongo DB:
* $ sh mongo.sh setup
*
* start mongo DB:
* $ sh mongo.sh start
*
* stop mongo DB:
* $ sh mongo.sh start
*
* @requires mongodb
* @requires file
*
* @module mongo
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

const file = require("./file.js")
const mongodb = require('mongodb')
const client = mongodb.MongoClient;
//var url = "mongodb://localhost:27017,localhost:27018,localhost:27019?replicaSet=mongo-repl"

/** mongodb server url to connect to 
* @default */
var url = "mongodb://localhost:27017?replicaSet=plait-repl"

/** mongodb client connection once returned by client connect */
var connection

/**
* connect to mongodb server based on url variable.
* adjust url variable if config contains a mongo url
*
* @todo fetch connection information from `mongo.sh setup`. Having to feed
* the config file with the mongo url is redundant
*/
function start(config) {
	return new Promise((resolve, reject) => {
		if(config.url) {
			url = config.url
		}
		
		log.info("MongoDB", "connecting to " + url)
		client.connect(url, { useNewUrlParser: true, useUnifiedTopology: true, poolSize: 100 })
			.then(conn => {
				connection = conn
				return resolve("started")
			})
			.catch(error => {
				return reject(error)
			})
	})
	
}

/**
*
* @todo stop mongo instance from running
*/
function stop() {

}

/**
* Allows access to a mongo Database.
*
* @param {Object} config
* @param {String} config.name - database ID
* @param {number} [config.url] - host and port of mongoDB and replikas. Optional if start() function was called
*
*/
class Database {
	constructor(config) {
		Object.assign(this, config)
		this.type = "mongodb"
	}

  /**
  * try connecting to existing database or create and connect if it
  * doesn't exist.
	*
	* add all existing collections as Collection Objects to Database Object
	*
	* increased pool size following this issue conversation:
	* https://jira.mongodb.org/browse/SERVER-32946
  *
  * @returns {Promise} resolves with "connected" if db existed, "created" if db was missing
  */
	connect() {
		return new Promise((resolve, reject) => {
			log.info(this.name, "Accessing Game Database")
			this.db = connection.db(this.name)
			
			this.db.listCollections().toArray()
			.then(collections => {
				if (collections.length > 0) {
					for (let i = 0; i &lt; collections.length; i++) {
						var col = collections[i].name
						log.debug(this.name, "Created collection Object of: " + col)
						this[col] = new Collection(col, this.db.collection(col))
					}
					log.info(this.name, "connected");
					resolve("connected")
				} else {
					log.info(this.name, "created");
					resolve("created")
				}
			})
			.catch(err => {
				if (err instanceof mongodb.MongoNetworkError) {
					log.error(0, "There was an error connecting to the mongo DB:")
					log.error(0, err)
				} else {
					reject(err)
				}
			})
		})
	}

	test(reject) {
		if (!reject) {
			return Promise.resolve("YAP")
		} else {
			return Promise.reject("NAA")
		}
	}

	/**
	* replace or create whole database from a properly formatted json file
	* @todo empty
	*/
	import(filename, callback) {

	}

	/**
	* return all collections in this databse as a list of strings
	*
	* @returns {Promise} array of Collection names (string).
	*/
	listCollections() {
		return new Promise((resolve, reject) => {
			this.db.listCollections().toArray()
				.then(function (result) {
					let colls = []
					for (let i = 0; i &lt; result.length; i++) {
						colls.push(result[i].name)
					}
					return resolve(colls)
				}.bind(this))
				.catch(function (error) {
					log.error(this.name, error)
					return reject(error)
				}.bind(this))
		})
	}

	/**
	* adds collection to mongo Database and to Database object
	*
	* @param {String} name - new collections name
	*
	* @returns {Promise} forwards response when done
	*/
	addCollection(name) {
		return new Promise(function (resolve, reject) {
			this.db.createCollection(name)
				.then(function (res) {
					this[name] = new Collection(name, this.db.collection(name))
					log.debug(0, "Added Collection " + name + " to " + this.name)
					resolve(res)
				}.bind(this))
				.catch(function (err) {
					log.error(this.name, err)
				}.bind(this))
		}.bind(this))
	}

	/**
	* drop the collection and delete the reference
	*
	* @param {String} name - to be dropped collections name
	*
	* @returns {Promise} forwards response when done
	*/
	dropCollection(name) {
		return new Promise(function (resolve, reject) {
			this[name].c.drop()
				.then(function (res) {
					if (res) {
						delete this[name]
					}
					resolve(res)
				}.bind(this))
				.catch(function (err) {
					log.error(this.name, err)
				}.bind(this))
		}.bind(this))
	}

	/**
	* Drop Database
	*/
	drop() {
		let name = this.name
		this.db.dropDatabase(this.name)
			.then(function (result) {
				log.info(0, "Database " + name + " deleted")
			})
			.catch(function (error) {
				log.error(0, error)
			})
	}

	/**
	* quit connection to database
	*/
	quit() {

	}
}

/**
* Collection Object that inherits a mongo collection and adds query functions
*
* @param {String} name - name of collection. Same as object instance name in Database Object
* @param {Object} col - Collection Object created from db connection
*/
class Collection {
	constructor(name, col) {
		this.name = name
		this.c = col
	}

	/**
	* @param {Object} query - json to identify Document
	*
	* @returns {Document} easier access to first document in this collection the query returns
	*/
	document(query) {
		return new Document(query, this)
	}

	/**
	* start a change stream
	*
	* @param {Object} [options] - see https://docs.mongodb.com/manual/changeStreams/#modify-change-stream-output for possible modification options
	*
	* @returns {Object} a mongodb Change stream (https://docs.mongodb.com/manual/changeStreams/)
	*/
	changes(options) {
		if (options) {
			var stream = this.c.watch(options)
		} else {
			var stream = this.c.watch()
		}
		return stream
	}
	
	/**
	* compare two _ids and return if they are equal
	*
	* @param {mongodb.ObjectID|String} idA - id to be checked against idB
	* @param {mongodb.ObjectID|String} idB - id to be checked against idA
	*
	* @returns {boolean} true if ids are equal
	*/
	compareIDs(idA, idB) {
		this.makeID(idA)
		this.makeID(idB)
		
		if(idA.equals(idB)) {
			return true
		} else {
			return false
		}
	}

	/**
	* @param {string} id - id to be transformed
	* @returns {mongodb.ObjectID} string id changed into mongo ObjectID
	*/
	makeID(id) {
		if(typeof(id) === "string") {
			return new mongodb.ObjectID(id)
		} else {
			return id
		}
	}

	/**
	* change existing document. Only objects mentioned in query are updated.
	* If you don't want to rewrite the object as a whole, use string dot notation
	* to specify the nested object
	*
	* prepends $set to updated data
	*
	* @param {Object} query - query what documents to update
	* @param {data} data - json of what is to be updated
	*
	*/
	set(query, data) {
		return new Promise((resolve, reject) => {
			this.update(query, { $set: data })
				.then(res => {
					return resolve(res)
				})
				.catch(err => {
					return reject(err)
				})
		})
	}

	/**
	* make a mongo document update using any of the update operators:
	* https://docs.mongodb.com/manual/reference/operator/update/
	*
	* @param {Object} query - query what documents to update
  * @param {data} data - json of what is to be updated
	*/
	update(query, data) {
		return new Promise((resolve, reject) => {
			if (query.hasOwnProperty('_id')) {
				query._id = this.makeID(query._id)
			}
			this.c.updateMany(query, this.encode(data))
				.then(res => {
					this.feedback(res)
					return resolve(res)
				})
				.catch(err => {
					log.error(this.name, err)
					return reject(err)
				})
		})
	}
	
	/**
	* make a mongo document replace. Replace 1st Document returned by query.
	*
	* @param {Object} query - query what documents to replace
  * @param {data} data - json of how the replaced document looks like
	* @param {data} options - see replaceOne options: https://docs.mongodb.com/manual/reference/method/db.collection.replaceOne/
	*/
	replace(query, data, options) {
		return new Promise((resolve, reject) => {
			if (query.hasOwnProperty('_id')) {
				query._id = this.makeID(query._id)
			}
			this.c.replaceOne(query, this.encode(data))
				.then(res => {
					this.feedback(res)
					return resolve(res)
				})
				.catch(err => {
					log.error(this.name, new Error(err))
					return reject(err)
				})
		})
	}

	/**
	* add new document to collection
	*
	* @returns {Promise} data about the inserted document including _id property
	*/
	insert(data) {
		return new Promise((resolve, reject) => {
			this.c.insertOne(this.encode(data))
				.then(res => {
					this.feedback(res)
					//log.info(this.name, res)
					return resolve(res)
				})
				.catch(err => {
					log.error(this.name, err)
					return reject(err)
				})
		})
	}

	/**
	* Some special characters in json schemes conflict with mongodb ($ and .) So they are replaced before update and after find
	*/
	setSchema(query, data) {
		return new Promise((resolve, reject) => {
			let c_data = this.encode(data)
			//log.info("SCHEMA",c_data.schema.cue.switch.properties.if.items.oneOf[2].properties)
			this.set(query, c_data)
				.then(result => {
					return resolve(result)
				})
				.catch(error => {
					log.error(this.name, error)
					return reject(error)
				})
		})
	}
	
	/**
	* Some special characters in json schemes conflict with mongodb ($ and .) So they are replaced before update and after find
	*/
	replaceSchema(query, data) {
		return new Promise((resolve, reject) => {
			let c_data = this.encode(data)
			this.replace(query, c_data)
				.then(result => {
					return resolve(result)
				})
				.catch(error => {
					log.error(this.name, error)
					return reject(error)
				})
		})
	}

	/**
	* 
	*/
	findSchema(query) {
		return new Promise((resolve, reject) => {
			this.find(query)
				.then(result => {
					for (let i = 0; i &lt; result.length; i++) {
						let c_res = this.decode(result[i])
						result[i] = c_res
						//log.info("RES", result[i].schema.cue)
					}
					return resolve(result)
				})
				.catch(error => {
					log.error(this.name, error)
					return reject(error)
				})
		})
	}

	/**
	* middle function before any update, replace or insert function.
	*
	* replace $ with similar looking char ＄ and . with ． in schemes.
	*
	* search and replace in schema property on first and second level.
	*
	* @todo maybe disclaim storing the schemes to the database. Afaik they are anyhow always updated based on external variables
	* 
	* idea from:
	* https://grokbase.com/t/gg/json-schema/133n7jfp8m/question-about-in-key-names-like-schema-and-ref#20130322rvyoejes76tyv5teeqsc6yma4e
	*
	* for readability it now uses stringification of object and string replace function.
	* might be quite performance heavy with big json objects and should not be used for time critical tasks.
	*/
	encode(obj) {
		if(Array.isArray(obj)) {return obj}
			
		if(obj.hasOwnProperty("schema")) {
			obj.schema = this.replaceEncode(obj.schema)
			
			return obj
		}
		if(obj.hasOwnProperty("control")) {
			obj.control = this.replaceEncode(obj.control)
			return obj
		}
		
		for(let o in obj) {
			if(obj[o].hasOwnProperty("schema")) {
				obj[o].schema = this.replaceEncode(obj[o].schema)
			}
			if(obj[o].hasOwnProperty("control")) {
				obj[o].control = this.replaceEncode(obj[o].control)
			}
		}
		return obj
		
	}
	
	replaceEncode(obj) {
		let obj_str = JSON.stringify(obj)
		obj_str = obj_str.replace(/\$ref/gm, "＄ref").replace(/\$schema/gm, "＄schema").replace(/\./gm, "．") // .replace(/\./gm, "．")
		return JSON.parse(obj_str)
	}
	
	/**
	* middle function before any return of find or distinct function
	*
	* replace ＄ with similar looking char $ and ． with . in schemes
	*
	* @todo find more efficient way of replacing keynames
	*/
	decode(obj) {
		if(Array.isArray(obj)) {
			for (let i = 0; i &lt; obj.length; i++) {
				let c_res = this.decode(obj[i])
				obj[i] = c_res
			}
			return obj
		}
		
		if(obj.hasOwnProperty("schema")) {
			obj.schema = this.replaceDecode(obj.schema)
		}
		if(obj.hasOwnProperty("control")) {
			obj.control = this.replaceDecode(obj.control)
		}
		
		return obj
	}
	
	replaceDecode(obj) {
		let obj_str = JSON.stringify(obj)
		obj_str = obj_str.replace(/\＄/gm, "$").replace(/\．/gm, ".")
		return JSON.parse(obj_str)
	}

	/**
	* get list of Documents based on query
	*
	* @param {Object} query - check docuemnts against query
	*
	* @returns {Promise} forwards an array of all found documents. Returns no rejection!
	*/
	find(query) {
		return new Promise((resolve, reject) => {
			if(query.hasOwnProperty("_id")) {
				query._id = this.makeID(query._id)
			}
			this.c.find(query).toArray()
				.then(result => {
					return resolve(this.decode(result))
				})
				.catch(error => {
					log.error(this.name, error)
				})
		});
	}

	/**
  * get specific element of Documents based on query.
  *
	* @param {Object} key - define key in documents you want to have returned
  * @param {Object} query - check docuemnts against query
  *
  * @returns {Promise} forwards an array of all found document keys. Returns no rejection!
  */
	distinct(key, query) {
		return new Promise((resolve, reject) => {
			this.c.distinct(key, query)
				.then(result => {
					resolve(this.decode(result))
				})
				.catch(error => {
					log.error(this.name, error)
				})
		});
	}
	
	/**
	*
	*  
	* @param {Object} query - check documents against query
	* @param {Object} sortBy - sort returned documents based on this object.
	*/
	sorted(query, sortBy) {
		return new Promise((resolve, reject) => {
			this.c.find(query).sort(sortBy).toArray()
				.then(result => {
					resolve(this.decode(result))
				})
				.catch(error => {
					log.error(this.name, error)
				})
		})
	}

	/**
	* return document if it contains a certain object
	*
	* @param {string} path - '.' notation path to object
	*/
	contains(path) {
		return new Promise(function (resolve, reject) {
			let query = {}
			query[path] = { $exists: true }
			this.c.find(query).toArray()
				.then(function (result) {
					resolve(this.decode(result))
				})
				.catch(function (error) {
					log.error(this.name, error)
				})
		}.bind(this));
	}
	
	/**
	* delte documents
	*
	* @param {Object} query - documents to be deleted
	*/
	delete(query) {
		return new Promise((resolve, reject) => {
			this.c.deleteMany(query)
			.then(result => {
				return resolve(result.deletedCount)
			})
			.catch(error => {
				log.error(this.name, error)
			})
		})
	}

	/**
	* delete documents based on query and return them
	*
	* @param {Object} query - what entries to cut out
	*
	* @returns {Promise} deleted documents as array
	*/
	slice(query) {
		return new Promise((resolve, reject) => {
			let docs = []
			this.c.find(query).toArray()
				.then(result => {
					docs = result
					return this.c.deleteMany(query)
				})
				.then(result => {
					resolve(this.decode(docs))
				})
				.catch(error => {
					log.error(this.name, error)
				})
		})
	}

	/**
	* use $unset to remove object from document
	*
	* @todo rename into unset()
	* this is not in use
	*
	* @param {Object} query - query to find docuemnts where you want to delete objects
	* @param {Object} obj - objects to to delete
	*
	* @returns {Promise} result
	*/
	truncate(query, obj) {
		return new Promise(function (resolve, reject) {
			this.c.updateMany(query, { $unset: obj })
				.then(function (res) {
					resolve(res)
				}.bind(this))
				.catch(function (error) {
					log.error(this.name, new Error(error))
				}.bind(this))
		}.bind(this));
	}


	/**
	* append item to array in object. Don't allow duplicates
	*
	* @param {Object} data - Array name/path and values to append
	*												use string with dot notation for nested array (e.g.: {'object.array':{key:value}})
	* @returns {Promise} amount of modified elements. 0 if none (e.g. duplicate)
	*/
	push(query, data) {
		return new Promise((resolve, reject) => {
			this.update(query, { $addToSet: data })
				.then(res => {
					//this.feedback(res)
					resolve(res) // resolve(res.modifiedCount)
				})
				.catch(err => {
					log.error(this.name, err)
				})
		})
	}

	/**
	* remove item from Array
	*/
	remove(query, pull_query) {
		return new Promise((resolve, reject) =>  {
			this.update(query, { $pull: pull_query })
				.then(result => {
					this.feedback(result)
					return resolve(result)
				})
				.catch(error => {
					// log.error(this.name, query)
					// log.error(this.name, pull_query)
					// log.error(this.name, error)
					return reject(error)
				})
		})
	}

	/**
	* remove item from array and return it. Works only with 1. level array so far
	*
	* @todo rebuild without findOneAndUpdate. Too many restrictions. Also it works different than
	* pick wich is confusing and, I guess, not necessary
	*
	* @param {Object} query - define what item to pull (e.g. {arrayname: {_id:"someid"}})
	*
	* @returns {Promise} returns removed document if successfull
	*/
	pull(query, pull_query) {
		return new Promise(function (resolve, reject) {
			let proj_doc = {}
			let array_key = ''
			for (var key in pull_query) {
				proj_doc[key] = {}
				proj_doc[key]['$elemMatch'] = pull_query[key]
				array_key = key
			}
			log.debug("Elem Match Projection: ")
			log.debug(0, proj_doc)
			this.c.findOneAndUpdate(query, { $pull: pull_query }, { returnNewDocument: false, projection: proj_doc })
				.then(function (result) {
					if (result.value.hasOwnProperty(array_key)) {
						if (result.value[array_key].length) {
							resolve(this.decode(result.value[array_key][0]))
						} else {
							reject('No element in ' + array_key)
						}
					} else {
						reject("Query didn't return " + array_key)
					}
				})
				.catch(function (error) {
					log.error(0, error)
				}.bind(this))
		}.bind(this));
	}

	/**
	* return only specific element in array.
	* based on $ projection operator:
	* https://docs.mongodb.com/manual/reference/operator/projection/positional/#proj._S_
	*
	* @param {Object} query - defines document to pick values from
	* @param {string} path - address of array where query is supposed to find an element in '.' notation (e.g. 'path.to.array')
	* @param {Object} arr_query - query in array (e.g. {'_id':12345}) to find element
	*
	* @returns {Promise} first(!) array element that is found with query. (returns only the element itself)
	*/
	pick(query, path, arr_query) {
		return new Promise((resolve, reject) => {
			let part_query = {}
			let root_query = Object.assign({}, query) // for some reason I don't quite get,
																								//the param query stays the same Object over several function calls
			for (let key in arr_query) {
				if (root_query.hasOwnProperty(key)) {
					part_query[path + '.' + key] = arr_query[key]
				}
			}

			let full_query = Object.assign(root_query, part_query)
			// log.debug(0, "pick Full Query: ")
			// log.debug(0, full_query)
			let proj = {}
			proj[path + '.$'] = 1
			// log.debug(0, "pick Value: ")
			// log.debug(0, proj)
			this.c.find(full_query).project(proj).toArray()
				.then(result => {
					if (result.length) {
						path = path.split('.')
						let value = result[0]
						while (path.length) {
							value = value[path.shift()]
						}
						return resolve(this.decode(value[0]))
					} else {
						return resolve({})
					}
				})
				.catch(error => {
					log.error(this.name, error)
				})
		})
	}

	/**
	* replace or create document from a properly formatted json file
	* @todo empty
	*/
	import(filename) {
		let json = filename.lastIndexOf('.json')
		if (json > 0) {
			var name = filename.substring(0, json) // obsolete

			file.loadJSON(filename)
				.then(function (result) {
					this.insert(result)
				}.bind(this))
		} else {
			log.error(this.name, "Import failed. " + filename + " is not a .json file")
		}
	}

	/**
	* write feedback of update or insert to debug log
	*
	* @param {Object} result - promise return of manipulating db query
	*/
	feedback(result) {
		if (result.hasOwnProperty('insertedCount')) {
			log.debug(this.name, "inserted " + result.insertedCount +  " Documents")

			if (result.insertedCount > 0) {
				return 'created'
			}
		} else {
			/*
			log.debug(this.name, "modified " + result.modifiedCount + ", matched " + result.matchedCount +
			 ", upserted " + result.upsertedCount)
			 */

			if (result.upsertedCount > 0) {
				return 'created'
			}
			if (result.modifiedCount > 0) {
				return 'updated'
			}
			if (result.matchedCount > 0) {
				return 'unchanged'
			}
		}

		return 'failed'
	}
}

/**
* Narrows any query down to the same document.
*
* @todo the document should not rely on the query that defined in in the init query  
* it should rather be reffered to by _id once the init query returned a document.
* But this seems to be a problem with the pick function
*
* @param {ObjectId} query - query to address one single record in mongodb
* @param {mongo.Collection} collection - collection that inherits this Document
*/
class Document {
	constructor(query, collection) {
		this.query = query
		this.col = collection
		this.colname = collection.name
		
		this.col.find(this.query)
			.then(result => {
				this._id = result[0]._id
				//this.query = {_id:result[0]._id} // Postponed. For some reason it creates an error with the pick function
			})
			.catch(error => {
				log.error(this.name, error)
			})
	}
	
	/**
	* get full document
	*
	* @returns {Promise} full document
	*/
	get() {
		return new Promise((resolve, reject) => {
			this.col.find(this.query)
				.then(result => {
					return resolve(result[0])
				})
				.catch(error => {
					log.error(this.name, error)
					return reject(error)
				})
		})
	}

	set(data) {
		return this.col.set(this.query, data)
	}

	update(data) {
		return this.col.update(this.query, data)
	}

	pick(path, arr_query) {
		return this.col.pick(this.query, path, arr_query)
	}

	pull(pull_query) {
		return this.col.pull(this.query, pull_query)
	}

	push(data) {
		return this.col.push(this.query, data)
	}
	
	remove(data) {
		return this.col.remove(this.query, data)
	}
}

module.exports = {
	Database: Database,
	Collection: Collection,
	Document:Document,
	start: start,
	stop: stop,
	client: client
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
